FormattingConversionServiceFactoryBean (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.format.support

## Class FormattingConversionServiceFactoryBean

- java.lang.Object
- - org.springframework.format.support.FormattingConversionServiceFactoryBean

- All Implemented Interfaces:
    Aware, FactoryBean<FormattingConversionService>, InitializingBean, EmbeddedValueResolverAware

      public class FormattingConversionServiceFactoryBean
      extends Object
      implements FactoryBean<FormattingConversionService>, EmbeddedValueResolverAware, InitializingBean

  A factory providing convenient access to a `FormattingConversionService` configured with converters and formatters for common types such as numbers and datetimes.

  Additional converters and formatters can be registered declaratively through `setConverters(Set)` and `setFormatters(Set)`. Another option is to register converters and formatters in code by implementing the `FormatterRegistrar` interface. You can then configure provide the set of registrars to use through `setFormatterRegistrars(Set)`.

  A good example for registering converters and formatters in code is `JodaTimeFormatterRegistrar`, which registers a number of date-related formatters and converters. For a more detailed list of cases see `setFormatterRegistrars(Set)`

  Like all `FactoryBean` implementations, this class is suitable for use when configuring a Spring application context using Spring `<beans>` XML. When configuring the container with `@Configuration` classes, simply instantiate, configure and return the appropriate `FormattingConversionService` object from a `@Bean` method.

  Since:
    3.0
  Author:
    Keith Donald, Juergen Hoeller, Rossen Stoyanchev, Chris Beams

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `FormattingConversionServiceFactoryBean()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
    `FormattingConversionService` | `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
    `Class<? extends FormattingConversionService>` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
    `protected void` | `installFormatters(FormatterRegistry registry)` Deprecated. since Spring 3.1 in favor of `setFormatterRegistrars(Set)`
    `boolean` | `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
    `void` | `setConverters(Set<?> converters)` Configure the set of custom converter objects that should be added.
    `void` | `setEmbeddedValueResolver(StringValueResolver embeddedValueResolver)` Set the StringValueResolver to use for resolving embedded definition values.
    `void` | `setFormatterRegistrars(Set<FormatterRegistrar> formatterRegistrars)` Configure the set of FormatterRegistrars to invoke to register Converters and Formatters in addition to those added declaratively via `setConverters(Set)` and `setFormatters(Set)`.
    `void` | `setFormatters(Set<?> formatters)` Configure the set of custom formatter objects that should be added.
    `void` | `setRegisterDefaultFormatters(boolean registerDefaultFormatters)` Indicate whether default formatters should be registered or not.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### FormattingConversionServiceFactoryBean

          public FormattingConversionServiceFactoryBean()

  - ### Method Detail

    - #### setConverters

          public void setConverters(Set<?> converters)

      Configure the set of custom converter objects that should be added.
      Parameters:
        `converters` - instances of any of the following: `Converter`, `ConverterFactory`, `GenericConverter`

    - #### setFormatters

          public void setFormatters(Set<?> formatters)

      Configure the set of custom formatter objects that should be added.
      Parameters:
        `formatters` - instances of `Formatter` or `AnnotationFormatterFactory`

    - #### setFormatterRegistrars

          public void setFormatterRegistrars(Set<FormatterRegistrar> formatterRegistrars)

      Configure the set of FormatterRegistrars to invoke to register Converters and Formatters in addition to those added declaratively via `setConverters(Set)` and `setFormatters(Set)`.

      FormatterRegistrars are useful when registering multiple related converters and formatters for a formatting category, such as Date formatting. All types related needed to support the formatting category can be registered from one place.

      FormatterRegistrars can also be used to register Formatters indexed under a specific field type different from its own <T>, or when registering a Formatter from a Printer/Parser pair.

      See Also:
        `FormatterRegistry.addFormatterForFieldType(Class, Formatter)`, `FormatterRegistry.addFormatterForFieldType(Class, Printer, Parser)`

    - #### setRegisterDefaultFormatters

          public void setRegisterDefaultFormatters(boolean registerDefaultFormatters)

      Indicate whether default formatters should be registered or not.

      By default, built-in formatters are registered. This flag can be used to turn that off and rely on explicitly registered formatters only.

      See Also:
        `setFormatters(Set)`, `setFormatterRegistrars(Set)`

    - #### setEmbeddedValueResolver

          public void setEmbeddedValueResolver(StringValueResolver embeddedValueResolver)

      Description copied from interface: `EmbeddedValueResolverAware`
      Set the StringValueResolver to use for resolving embedded definition values.
      Specified by:
        `setEmbeddedValueResolver` in interface `EmbeddedValueResolverAware`

    - #### afterPropertiesSet

          public void afterPropertiesSet()

      Description copied from interface: `InitializingBean`
      Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

      This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

      Specified by:
        `afterPropertiesSet` in interface `InitializingBean`

    - #### installFormatters

          @Deprecated
          protected void installFormatters(FormatterRegistry registry)

      Deprecated. since Spring 3.1 in favor of `setFormatterRegistrars(Set)`
      Subclasses may override this method to register formatters and/or converters. Starting with Spring 3.1 however the recommended way of doing that is to through FormatterRegistrars.
      See Also:
        `setFormatters(Set)`, `setFormatterRegistrars(Set)`

    - #### getObject

          public FormattingConversionService getObject()

      Description copied from interface: `FactoryBean`
      Return an instance (possibly shared or independent) of the object managed by this factory.

      As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

      If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

      As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

      Specified by:
        `getObject` in interface `FactoryBean<FormattingConversionService>`
      Returns:
        an instance of the bean (can be `null`)
      See Also:
        `FactoryBeanNotInitializedException`

    - #### getObjectType

          public Class<? extends FormattingConversionService> getObjectType()

      Description copied from interface: `FactoryBean`
      Return the type of object that this FactoryBean creates, or `null` if not known in advance.

      This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

      In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

      This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

      NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

      Specified by:
        `getObjectType` in interface `FactoryBean<FormattingConversionService>`
      Returns:
        the type of object that this FactoryBean creates, or `null` if not known at the time of the call
      See Also:
        `ListableBeanFactory.getBeansOfType(java.lang.Class<T>)`

    - #### isSingleton

          public boolean isSingleton()

      Description copied from interface: `FactoryBean`
      Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

      NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

      The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

      NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

      Specified by:
        `isSingleton` in interface `FactoryBean<FormattingConversionService>`
      Returns:
        whether the exposed object is a singleton
      See Also:
        `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`